# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from cxutil import cmask
from cxutil import utils
from cxutil import pmask
from command import command
from cxutil.exceptions import Dump

class call(command):
	'''
	Call a function
	'''
	mask = flags.Esoteric | flags.Internal
	parameters = {
		"$1": {"description": "Function name", "name": "call", "type": "word"},
		"$2": {"description": "Function parameter string", "name": "fps", "type": "string", "mask": pmask.Optional},
	}

	def action(self,opts):
		root = opts["esoteric"]["root"]
		creds = opts["creds"]
		oid = opts["oid"]
		locs = opts["envl"]
		result = root.functions[locs["call"]].commit(creds,"debug",oid,locs, mask = cmask.Force | cmask.Call)
		utils.merge(result["rest"],opts.rest_tp)
		return result["services"]

	def postUp(self,opts):
		###
		# run up anyway
		###
		return self.action(opts)

	def postDown(self,opts):
		###
		# run down only if called inside script calls
		#
		# FIXME: one must to do this right way once...
		###
		if opts.esoteric.call_mask & cmask.ScriptDown:
			return self.action(opts)
		else:
			return command.postDown(self,opts)
