# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from cxutil import pmask
from command import command
from cxutil.exceptions import Dump

class comment(command):
	'''
	Input a comment for the next command
	'''
	name = "!"
	mask = flags.Esoteric | flags.Internal | flags.Immediate
	parameters = {
		"$1": {
			"type": "string",
			"name": "comment",
			"description": "a comment line",
			"mask": pmask.Optional,
		}
	}

	def postUp(self,opts):
		if opts["envl"].has_key("comment"):
			opts["esoteric"]["comment"].append(opts["envl"]["comment"])
		else:
			opts["esoteric"]["comment"].append("")
