# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command,swrapper
from state.syntax import oparser
from state.core import state2
from cxutil import flags
from cxutil import pmask
from cxutil.exceptions import Dump

class declare(command):
	'''
	Declare a function
	'''
	parameters = {"$1": {"description": "function name", "name": "function", "type": "word", "mask": pmask.Optional}}
	mask = flags.Esoteric | flags.Internal
	
	def immediate(self,opts):
		node = opts["esoteric"]["node"].parent
		root = opts["esoteric"]["root"]
		oid = opts["oid"]

		if opts["envl"].has_key("function"):
			name = opts["envl"]["function"]
		elif node.opts.fname:
			name = node.opts.fname
		else:
		        name = node.fn.replace(" ","_").replace("\t","_")

		if name in node.declare:
			return None

		node.declare.append(name)
		node.declare_counter += 1
		root.functions[name] = node

