# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from command import command, swrapper
from string import Template
from copy import deepcopy

class Default(command):
	'''
	Run a shell command
	'''
	mask = flags.Esoteric | flags.Internal
	name = "exec"

	parameters = {
		"$1": {"description": "Shell command[s] to run", "name": "call", "type": "string"},
	}

	def postUp(self,opts):

		call = opts.envl.call

		# substitute signal templates in the command line
		# this was done for /usr/bin/logger

		if opts.envl.has_key("signal"):
			call = Template(call)
			try:
				s = dict(deepcopy(opts.envl.signal))
				s["signal"] = deepcopy(opts.envl.signal)
				s["signal_id"] = opts.envl.sigid
			except:
				s = {}
			call = call.safe_substitute(s)

		result = swrapper()
		result.add_command("system",call)

		return result
