# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command,swrapper
from cxutil.exceptions import Dump,CallPass
from cxutil import flags
from cxutil import cmask
from state.core import state2
from state.syntax import oparser
from os import popen2

class Default(command):
	'''
	Declare a branch filter
	'''
	name = "filter"
	mask = flags.Esoteric | flags.Begin | flags.LocalsTransparent
	parameters = {
		"$1": {
			"description": "Filter ID",
			"type": "string",
			"name": "filter"
		}
	}
	modules = [
		["t","type"],
	]


	def immediate(self,opts):
		root = opts["esoteric"]["root"]
		node = opts["esoteric"]["node"]
		name = opts["envl"]["filter"]
		oid = opts["oid"]

		if root.filters.has_key(name):
			return

		root.filters[name] = node
		node.declare_counter = 1

	def pre(self,opts):
		command.pre(self,opts)
		opts["envl"]["pass"] = []


	class t(command):
		'''
		Filter type
		'''
		name = "type"
		parameters = {
			"$1": {
				"description": "Filter type",
				"type": "enum",
				"range": ("positive","negative"),
				"name": "filter_type",
			}
		}
