# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command,swrapper
from cxutil import flags
from cxutil import cmask
from cxutil.utils import Executor

class hostname(command):
	'''
	Host filter
	'''
	mask = flags.Esoteric
	parameters = {
		"$1": {
			"description": "hostname to match",
			"type": "string",
			"name": "hostname",
		}
	}
	def postUp(self,opts):
		fs = opts["envl"]["pass"]
		fn = opts["esoteric"]["node"].fn
		s = Executor("hostname").data.strip()

		if s == opts["envl"]["hostname"]:
			fs.append((fn,True))
		else:
			fs.append((fn,False))

