# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command,swrapper
from cxutil import flags
from cxutil import cmask
from cxutil.utils import Executor
import re

class nic(command):
	'''
	NIC address filter
	'''
	mask = flags.Esoteric
	r = re.compile("^\s*link/ether\s+(([0-9a-f]{2}:?){6})\s.+$",re.U)
	parameters = {
		"$1": {
			"description": "NIC hardware address to match",
			"type": "string",
			"name": "nic",
		}
	}

	def postUp(self,opts):
		fs = opts["envl"]["pass"]
		fn = opts["esoteric"]["node"].fn
		s = Executor("/sbin/ip link").lines

		fs.append((fn,False))
		for i in s:
			i = i.strip()
			if self.r.match(i):
				if self.r.sub("\\1",i) == opts["envl"]["nic"]:
					fs.pop()
					fs.append((fn,True))

