# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from command import command

class no(command):
	'''
	Cancel an operation
	'''
	mask = flags.Internal | flags.Esoteric | flags.Immediate
	parameters = {"$1": {"type": "string", "name": "line", "description": "a command line to abort"}}

	def postUp(self,opts):
		node = opts["esoteric"]["node"].parent
		line = opts["envl"]["line"]
		oid = opts["oid"]

		if node.children.has_key(line):
			## remove subscriptions for all children:
			self.unSub(node,node)
			## remove the child itself
		        node = node.children[line]
		        node.cancel(oid)
		else:
		        return "no such command to cancel\n"


	def unSub(self,root,node):
		'''
		remove subscriptions of all child nodes
		'''
		for (i,k) in node.children.items():
			self.unSub(root,k)
			for l in k.module.subscribe:
				if root.subscriptions.has_key(l):
					if k in node.subscriptions[l]:
						node.subscriptions[l].remove(k)
