# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from cxutil import cmask
from cxutil.utils import merge
from cxutil.exceptions import Dump,BranchPass
from command import command

class on(command):
	'''
	Use a filter for subtree
	'''
	mask = flags.Begin | flags.Transparent | flags.Esoteric
	parameters = {
		"$1": {
			"description": "Filter name to use",
			"type": "string",
			"name": "filter",
		}
	}

	def pre(self,opts):
		command.pre(self,opts)
		if opts["esoteric"]["call_mask"] & cmask.Immediate:
			return

		root = opts["esoteric"]["root"]
		node = opts["esoteric"]["node"]
		creds = opts["creds"]
		oid = opts["oid"]
		locs = opts["envl"]
		locs["pass"] = []
		if root.filters.has_key(locs["filter"]):
			env = root.filters[locs["filter"]].commit(creds,"debug",oid,locs, mask = cmask.Force | cmask.Call)
			merge(env["up"],locs)
			p = False
			for i in locs["pass"]:
				if i[1]:
					p = True
			if not p:
				raise BranchPass
