# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from cxutil import cmask
from cxutil import utils
from cxutil import pmask
from command import command, swrapper

class run(command):
	'''
	Run an internal script (declared with `script` command)
	'''
	mask = flags.Esoteric | flags.Internal
	parameters = {
		"$1": {"description": "Script name", "name": "call", "type": "word"},
		"$2": {"description": "Script parameter string", "name": "fps", "type": "string", "mask": pmask.Optional},
	}

	def postUp(self,opts):

		result = swrapper()
		rs = []

		root = opts["esoteric"]["root"]
		creds = opts["creds"]
		oid = opts["oid"]
		locs = opts["envl"]
		cid = opts.envl.call

		if root.scripts.has_key(cid):
			for i in root.scripts[cid]:
				i.mark(oid)
				i.mark(oid,"down")

				mask = cmask.Empty

				if i.public.mode == "up":
					mask |= cmask.ScriptUp
				elif i.public.mode == "down":
					mask |= cmask.ScriptDown

				r = root.commit(creds,"debug",oid,locs,mask = mask)
				rs.extend(r["services"])
				utils.merge(r["rest"],opts.rest_tp)

		result.merge(rs)
		return result
