# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from cxutil.exceptions import Dump
from command import command

class script(command):
	'''
	Define a subtree as a script
	'''
	mask = flags.Begin | flags.Transparent | flags.Esoteric | flags.LocalsTransparent
	parameters = {
		"$1": {
			"description": "Script name to use",
			"type": "word",
			"name": "name",
		},
		"$2": {
			"description": "Script mode",
			"type": "enum",
			"range": ('up','down'),
			"default": "up",
			"name": "mode",
		}
	}

	def immediate(self,opts):
		opts.public.script = opts.envl.name
		opts.public.mode = opts.envl.mode

